P6279 题解

P6279 题解

Overview

结论(待论证)

Description

给定一个有向图,这个有向图的每一个点所连接的点都属于同一个集合。

求集合数量最大且字典序最小的集合标号方案。

Solution

先讲结论。

结论 :用 vector 存储每个点所连接的点,从 1 1 1 到 n n n 暴力用并查集按秩 合并(要合并 vector 的东西,一层一层的合并下去)。

Proof

先讲复杂度。

时间复杂度 O ( α ( n ) ) O(\alpha (n)) O(α(n))。

按秩合并空间复杂度 O ( n ) O(n) O(n),vector 的存储的东西的空间被 clear 了,(其实我也不清楚 clear 的原理)所以没事。

再讲正确性。

这里,合并一定会合并到底。

Code

cpp 复制代码
#include <bits/stdc++.h>
#define int long long

using namespace std;

int fa[200001], sz[200001];
vector<int> vec[200001];

int FindFather(int x){
	if(fa[x] == x) return x;
	int tmp = FindFather(fa[x]);
	sz[x] = sz[fa[x]] + 1;
	return fa[x] = tmp;
}
void Union(int u, int v){
	u = FindFather(u), v = FindFather(v);
	if(u == v) return;
	if(sz[u] < sz[v]) swap(u, v);
	sz[u] += sz[v];
	fa[v] = u;
	for(int i = 0; i < vec[v].size(); i++)
		if(vec[u].size()) Union(vec[u][0], vec[v][i]);
	for(int i = 0; i < vec[v].size(); i++)
		vec[u].push_back(vec[v][i]);
}

signed main(){
	int n, m; cin >> n >> m;
	for(int i = 1; i <= n; i++) fa[i] = i;
	for(int i = 1; i <= m; i++){
		int u, v; cin >> u >> v;
		vec[u].push_back(v);
	}
	for(int i = 1; i <= n; i++){
		if(vec[i].size() > 1){
			for(int j = 0; j < vec[i].size() - 1; j++){
				Union(vec[i][j], vec[i][j + 1]);
			}
		}
	}
	map<int, int> mp;
	int tot = 0;
	for(int i = 1; i <= n; i++){
		if(!mp[FindFather(i)]) mp[fa[i]] = ++tot;
		cout << mp[fa[i]] << endl;
	}
	return 0;
}
相关推荐
qq_4017004119 分钟前
Qt 串口/网口通信:Hex 与 ASCII 编码转换深度指南
开发语言·数据库·qt
佳児素花痴╮30 分钟前
线程知识点
java·开发语言·jvm
学掌门1 小时前
老司机带你十分钟入门Python!
开发语言·python
镜子AI1 小时前
教培机构AI推荐系统实战:概念漂移检测算法——为什么“去年有效的推荐今年可能失效“
人工智能·算法
zhangzeyuaaa1 小时前
深入 Ruby:return 退出规则完全指南
开发语言·ruby
shaibdoio2 小时前
AI主动获客的意图识别工程实现:从规则匹配到模型微调
java·开发语言·人工智能·长沙瞬维ai
垆边人似月.2 小时前
华为OD算法题:查找众数及中位数
数据结构·算法·leetcode
hetao17338372 小时前
2026-10-08 hetao1733837 的刷题记录
c++·算法
CoderYanger3 小时前
一轮复习——F.动态规划模型总结(入门篇)
java·开发语言·数据结构·算法·leetcode·职场和发展·动态规划
Frank_refuel3 小时前
【C++】智能指针
开发语言·c++